/*
 *  Copyright (C) 2006 Ludovic Jacomme (ludovic.jacomme@gmail.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

# ifndef _KBD_H_
# define _KBD_H_

# define PSP_ALL_BUTTON_MASK 0xFFFF

 enum cv_keys_emum {
    CV_0           ,
    CV_1           ,
    CV_2           ,
    CV_3           ,
    CV_4           ,
    CV_5           ,
    CV_6           ,
    CV_7           ,
    CV_8           ,
    CV_9           ,
    CV_ASTERISK    ,
    CV_POUND       ,
    CV_JOY_FIRE1   ,
    CV_JOY_FIRE2   ,
    CV_JOY_UP      ,
    CV_JOY_DOWN    ,
    CV_JOY_LEFT    ,
    CV_JOY_RIGHT   ,
    CV_RESET       ,
    CV_USER1       ,
    CV_USER2       ,
    CVC_FPS,
    CVC_JOY,
    CVC_RENDER,
    CVC_LOAD,
    CVC_SAVE,
    CVC_RESET,
    CVC_AUTOFIRE,
    CVC_INCFIRE,
    CVC_DECFIRE,
    CVC_INCDELTA,
    CVC_DECDELTA,
    CVC_SCREEN,

    CV_MAX_KEY      
  };

# define KBD_UP           0
# define KBD_RIGHT        1
# define KBD_DOWN         2
# define KBD_LEFT         3
# define KBD_TRIANGLE     4
# define KBD_CIRCLE       5
# define KBD_CROSS        6
# define KBD_SQUARE       7
# define KBD_SELECT       8
# define KBD_START        9
# define KBD_HOME        10
# define KBD_HOLD        11
# define KBD_LTRIGGER    12
# define KBD_RTRIGGER    13

# define KBD_MAX_BUTTONS 14

# define KBD_JOY_UP      14
# define KBD_JOY_RIGHT   15
# define KBD_JOY_DOWN    16
# define KBD_JOY_LEFT    17

# define KBD_ALL_BUTTONS 18

# define KBD_UNASSIGNED         -1

# define KBD_LTRIGGER_MAPPING   -2
# define KBD_RTRIGGER_MAPPING   -3
# define KBD_NORMAL_MAPPING     -1

 struct cv_key_trans {
   int  key;
   char name[32];
 };
  
  extern char kbd_button_name[ KBD_ALL_BUTTONS ][10];

  extern int psp_screenshot_mode;
  extern int psp_kbd_mapping[ KBD_ALL_BUTTONS ];
  extern int psp_kbd_mapping_L[ KBD_ALL_BUTTONS ];
  extern int psp_kbd_mapping_R[ KBD_ALL_BUTTONS ];
  extern int psp_kbd_presses[ KBD_ALL_BUTTONS ];
  extern int kbd_ltrigger_mapping_active;
  extern int kbd_rtrigger_mapping_active;
  extern unsigned int kbd_button_mask[ KBD_MAX_BUTTONS ];

  extern struct cv_key_trans psp_cv_key_to_name[CV_MAX_KEY];

  extern int  psp_update_keys(void);
  extern void kbd_wait_start(void);
  extern void psp_init_keyboard(void);
  extern void psp_kbd_wait_no_button(void);
  extern int  psp_kbd_is_danzeff_mode(void);
  extern int psp_kbd_load_mapping(char *kbd_filename);
  extern int psp_kbd_save_mapping(char *kbd_filename);
  extern void psp_kbd_display_active_mapping(void);
  extern void kbd_change_auto_fire(int auto_fire);
# endif
